#!/usr/bin/env Rscript



###### set variables; load libs #####################
.libPaths(new="~/R/x86_64-redhat-linux-gnu-library/3.5")
suppressMessages(library(Biobase, quietly = T))
suppressMessages(library(reshape2, quietly = T))
suppressMessages(library(ggplot2, quietly = T))
suppressMessages(library(gridExtra, quietly = T))
suppressMessages(library(grid, quietly = T))
suppressMessages(library(NMF, quietly = T))
suppressMessages(library(RobustRankAggreg, quietly = T))
# suppressMessages(library(sva, quietly = T))
# suppressMessages(library(limma,quietly = T))



###### sub-routines #################################
GetName <- function(x,y=2){  return(gsub("wd_","",strsplit( paste0(strsplit(x, split = "/")[[1]][c(y,y+1)], collapse = "-") , split = "\\." )[[1]][1])) }

gm_mean = function(x, na.rm=TRUE, zero.propagate = FALSE){
  if(any(x < 0, na.rm = TRUE)){
    return(NaN)
  }
  if(zero.propagate){
    if(any(x == 0, na.rm = TRUE)){
      return(0)
    }
    exp(mean(log(x), na.rm = na.rm))
  } else {
    exp(sum(log(x[x > 0]), na.rm=na.rm) / length(x))
  }
}

NormalizeLikeDEseq <- function(x,ref = PseudoRef){
  if (!(all(names(ref) == rownames(mat)))){
    stop()
  }
  else if(all(names(ref) == rownames(mat))){
    
    ratios <- apply(mat, MARGIN = 2, function(m){m/ref})
    
    ColMedians <- apply(ratios, MARGIN = 2, median)
    
    norm = function(s,m){s/m}
    
    mat.norm <- mat
    
    for (i in 1:length(ColMedians)){
      mat.norm[,i] <- norm(s = mat[,i], m = ColMedians[i])
    }
    
    l <- list()
    l[[1]] <- mat
    l[[2]] <- mat.norm
    l[[3]] <- ColMedians
    names(l) <- c("input_counts","normalized_counts","scaling_factors")
    
    return(l)
  }
  
}

BatchRemove <- function(mat, batchMat, log2trans=FALSE, positive = FALSE){
  if(class(mat)=="character" && file.exists(mat)){
    mat = read.table(mat, sep = "\t", header = TRUE, stringsAsFactors = FALSE)
  }
  if(class(batchMat)=="character" && file.exists(batchMat)){
    batchMat = read.table(batchMat, sep = "\t", header = TRUE, stringsAsFactors = FALSE)
  }
  #requireNamespace("sva")
  mat = as.matrix(mat)
  if(mode(mat)!="numeric") stop("Numeric data matrix is needed!")
  batch = as.matrix(batchMat)
  rownames(batch) = batch[,1]
  ## load batch matrix
  index=intersect(batch[,1], colnames(mat))
  if(length(index)<2) stop("Less than two samples found in data matrix.")
  dt=mat[,index]
  if(log2trans) dt = log(dt+1)
  ##
  tmp=dt
  var0=numeric()
  for (i in unique(batch[,2])){
    temp=as.character(batch[batch[,2]==i,1])
    if (length(temp)>=2){
      temp2=tmp[,temp]
      var.data.tmp <- apply(temp2, 1,function(x) var(x))
      var.data.tmp0=which(var.data.tmp==0)
      var0=c(var0,var.data.tmp0)
    }
  }
  tmp2 = tmp
  if(length(var0)>0) tmp2=tmp[setdiff(1:nrow(tmp),var0),]
  if(ncol(batch)>2){
    mod = as.data.frame(batch[,3:ncol(batch)])
    mod = model.matrix(~., data=mod)
  }else mod = NULL
  if(length(unique(batch[,2]))<2){
    res = tmp2
  }else{res <- sva::ComBat(tmp2, batch = batch[,2], mod = mod)}
  if(positive) res[res<0] = 0
  if(length(setdiff(colnames(mat), colnames(res)))>0){
    res=cbind(mat[setdiff(1:nrow(tmp),var0), setdiff(colnames(mat),colnames(res))], res)
    colnames(res)[1:length(setdiff(colnames(mat), colnames(res)))] = setdiff(colnames(mat),colnames(res))
  }
  if(length(var0)>0){
    res = rbind(res, mat[var0, colnames(res)])
  }
  
  # dt2 = matrix(as.numeric(res[,index]), ncol = length(index))
  # colnames(dt2) = index
  # rownames(dt2) = rownames(res)
  dt2 = res[,index]
  pca1 = NULL
  pca2 = NULL
  p1 = NULL
  
  pca1 = prcomp(t(na.omit(dt)))$x[,1:2]
  pca2 = prcomp(t(na.omit(dt2)))$x[,1:2]
  
  gg1 = as.data.frame(pca1, stringsAsFactors=FALSE)
  gg1$col = batch[rownames(gg1),2]
  gg1$group = factor("Before batch removal", "Before batch removal")
  gg2 = as.data.frame(pca2,stringsAsFactors=FALSE)
  gg2$col = batch[rownames(gg2),2]
  gg2$group = factor("After batch removal", "After batch removal")
  if(ncol(batch)>2){
    gg1$shape = as.character(batch[rownames(gg1),3])
    gg2$shape = batch[rownames(gg2),3]
  }else{ gg1$shape = "NA"; gg2$shape = "NA" }
  gg = rbind.data.frame(gg1, gg2)
  
  #====plot PC1 and PC2=====
  p1 = ggplot(gg, aes(x=PC1, y=PC2, color=col, shape=shape))
  p1 = p1 + geom_point(size = 2)
  p1 = p1 + scale_color_discrete(name="Batch", breaks = unique(gg$col))
  #p1 = p1 + scale_shape_discrete(name="Batch", breaks = unique(gg$col))
  p1 = p1 + theme_bw(14)+theme(plot.title = element_text(hjust = 0.5,size=12))
  p1 = p1 + facet_grid(~group, switch = "y", scales="free")
  p1 = p1 + theme(legend.title=element_blank())
  
  
  
  pca1 = prcomp(t(na.omit(dt)))$x[,2:3]
  pca2 = prcomp(t(na.omit(dt2)))$x[,2:3]
  
  gg1 = as.data.frame(pca1, stringsAsFactors=FALSE)
  gg1$col = batch[rownames(gg1),2]
  gg1$group = factor("Before batch removal", "Before batch removal")
  gg2 = as.data.frame(pca2,stringsAsFactors=FALSE)
  gg2$col = batch[rownames(gg2),2]
  gg2$group = factor("After batch removal", "After batch removal")
  if(ncol(batch)>2){
    gg1$shape = as.character(batch[rownames(gg1),3])
    gg2$shape = batch[rownames(gg2),3]
  }else{ gg1$shape = "NA"; gg2$shape = "NA" }
  gg = rbind.data.frame(gg1, gg2)
  
  #====plot PC2 and PC3=====
  p2 = ggplot(gg)
  p2 = p2 + geom_point(aes(x=PC2, y=PC3, color=col, shape=shape),size = 2)
  p2 = p2 + scale_color_discrete(name="Batch", breaks = unique(gg$col))
  #p2 = p2 + scale_shape_discrete(name="Batch", breaks = unique(gg$col))
  p2 = p2 + theme_bw(14)+theme(plot.title = element_text(hjust = 0.5,size=12))
  p2 = p2 + facet_grid(~group, switch = "y", scales="free")
  p2 = p2 + theme(legend.title=element_blank())
  
  
  
  pca1 = prcomp(t(na.omit(dt)))$x[,3:4]
  pca2 = prcomp(t(na.omit(dt2)))$x[,3:4]
  
  gg1 = as.data.frame(pca1, stringsAsFactors=FALSE)
  gg1$col = batch[rownames(gg1),2]
  gg1$group = factor("Before batch removal", "Before batch removal")
  gg2 = as.data.frame(pca2,stringsAsFactors=FALSE)
  gg2$col = batch[rownames(gg2),2]
  gg2$group = factor("After batch removal", "After batch removal")
  if(ncol(batch)>2){
    gg1$shape = as.character(batch[rownames(gg1),3])
    gg2$shape = batch[rownames(gg2),3]
  }else{ gg1$shape = "NA"; gg2$shape = "NA" }
  gg = rbind.data.frame(gg1, gg2)
  
  #====plot PC3 and PC4=====
  p3 = ggplot(gg)
  p3 = p3 + geom_point(aes(x=PC3, y=PC4, color=col, shape=shape),size = 2)
  p3 = p3 + scale_color_discrete(name="Batch", breaks = unique(gg$col))
  #p3 = p3 + scale_shape_discrete(name="Batch", breaks = unique(gg$col))
  p3 = p3 + theme_bw(14)+theme(plot.title = element_text(hjust = 0.5,size=12))
  p3 = p3 + facet_grid(~group, switch = "y", scales="free")
  p3 = p3 + theme(legend.title=element_blank())
  
  ##====Clustering========
  # if(cluster){
  #   filename = file.path(outdir, paste0(prefix, "_hclust_batchremoval.pdf"))
  #   if(is.na(hclust.height) | is.na(hclust.width))
  #     pdf(filename, height=0.5*nrow(batch)+2, width=0.05*nrow(batch)+3)
  #   else
  #     pdf(filename, height=hclust.height, width=hclust.width)
  #   cc2 = cor(dt)
  #   cc=cor(dt2)
  #   if(ncol(batch)>2){
  #     hclustView(cc2, label_cols = batch[rownames(cc2),3], bar_cols = batch[rownames(cc2),2:ncol(batch)], main = "Before batch removal")
  #     hclustView(cc, label_cols = batch[rownames(cc),3], bar_cols = batch[rownames(cc),2:ncol(batch)], main = "After batch removal")
  #
  #   }else{
  #     hclustView(cc2, label_cols = batch[rownames(cc2),2], main = "Before batch removal")
  #     hclustView(cc, label_cols = batch[rownames(cc),2], main = "After batch removal")
  #   }
  #   dev.off()
  # }
  return(list(data=res, p1=p1, p2=p2, p3=p3))
}




Plot.pca <- function(x, NAME = NULL , LVLs = c("D0" ,"D7", "D14", "D21", "D27"  )){
  PC<-prcomp(log2(na.omit(x)))
  
  df_out_r <- as.data.frame(PC$rotation)
  df_out_r$feature <- row.names(df_out_r)
  df_out_r$batch <- sapply(df_out_r$feature,function(x){strsplit(x, split="_")[[1]][1]})
  df_out_r$bin <- sapply(df_out_r$feature,function(x){strsplit(x, split="_")[[1]][2]})
  
  df_out_r$batch = factor(df_out_r$batch , levels = names(table(df_out_r$batch)) )
  df_out_r$bin = factor(df_out_r$bin , levels = LVLs )
  
  max.x <- max(PC$rotation[,1])
  max.y <- max(PC$rotation[,2])
  min.x <- min(PC$rotation[,1])
  min.y <- min(PC$rotation[,2])
  
  ratio = abs(min.x - max.x)/abs(min.y - max.y) # get plot dimensions
  
  g1 <- ggplot(df_out_r,aes(x=PC1,y=PC2,color=batch, shape=bin  )) + geom_point(size=3)+theme_classic() + coord_fixed(ratio=ratio) + ggtitle(NAME)
  
  
  
  max.x <- max(PC$rotation[,2])
  max.y <- max(PC$rotation[,3])
  min.x <- min(PC$rotation[,2])
  min.y <- min(PC$rotation[,3])
  
  ratio = abs(min.x - max.x)/abs(min.y - max.y) # get plot dimensions
  
  g2 = ggplot(df_out_r,aes(x=PC2,y=PC3,color=batch, shape=bin  )) + geom_point(size=3)+theme_classic() + coord_fixed(ratio=ratio) + ggtitle(NAME)
  
  
  return(list(g1,g2))
  
  
}

# now updated, log2 instead of log
getCSscore <-function( query , ref ){
  return(log2(query/ref))
}


AssignCScore <- function(x){
  
  # initialize in and output
  mat = x
  mat.cs = mat
  
  # calculate CS in a quick and dirty way; could possibly be done nicer
  mat.cs[,which(colnames(mat.cs) == "R1_D7")] <- getCSscore(query = mat[,which(colnames(mat) == "R1_D7")], ref= mat[,which(colnames(mat) == "R1_D0")] )
  mat.cs[,which(colnames(mat.cs) == "R2_D7")] <- getCSscore(query = mat[,which(colnames(mat) == "R2_D7")], ref= mat[,which(colnames(mat) == "R2_D0")] )
  mat.cs[,which(colnames(mat.cs) == "R3_D7")] <- getCSscore(query = mat[,which(colnames(mat) == "R3_D7")], ref= mat[,which(colnames(mat) == "R3_D0")] )
  
  mat.cs[,which(colnames(mat.cs) == "R1_D14")] <- getCSscore(query = mat[,which(colnames(mat) == "R1_D14")], ref= mat[,which(colnames(mat) == "R1_D0")] )
  mat.cs[,which(colnames(mat.cs) == "R2_D14")] <- getCSscore(query = mat[,which(colnames(mat) == "R2_D14")], ref= mat[,which(colnames(mat) == "R2_D0")] )
  mat.cs[,which(colnames(mat.cs) == "R3_D14")] <- getCSscore(query = mat[,which(colnames(mat) == "R3_D14")], ref= mat[,which(colnames(mat) == "R3_D0")] )
  
  mat.cs[,which(colnames(mat.cs) == "R1_D21")] <- getCSscore(query = mat[,which(colnames(mat) == "R1_D21")], ref= mat[,which(colnames(mat) == "R1_D0")] )
  mat.cs[,which(colnames(mat.cs) == "R2_D21")] <- getCSscore(query = mat[,which(colnames(mat) == "R2_D21")], ref= mat[,which(colnames(mat) == "R2_D0")] )
  mat.cs[,which(colnames(mat.cs) == "R3_D21")] <- getCSscore(query = mat[,which(colnames(mat) == "R3_D21")], ref= mat[,which(colnames(mat) == "R3_D0")] )
  
  
  mat.cs[,which(colnames(mat.cs) == "R1_D27")] <- getCSscore(query = mat[,which(colnames(mat) == "R1_D27")], ref= mat[,which(colnames(mat) == "R1_D0")] )
  mat.cs[,which(colnames(mat.cs) == "R2_D27")] <- getCSscore(query = mat[,which(colnames(mat) == "R2_D27")], ref= mat[,which(colnames(mat) == "R2_D0")] )
  mat.cs[,which(colnames(mat.cs) == "R3_D27")] <- getCSscore(query = mat[,which(colnames(mat) == "R3_D27")], ref= mat[,which(colnames(mat) == "R3_D0")] )
  
  # remove inputs
  mat.cs <- mat.cs[,grep("D0",colnames(mat.cs), invert = T)]
  
  # return CS matrix
  return(mat.cs)
  
}


GetType = function(x){
  if(grepl("_T",x)){
    return("TOP")
  }
  else if (grepl("_B",x)){
    return("BOTTOM")
  }
  else{
    return("Non-Targeting")
  }
}

RunRRA <- function(x, NAME = NULL , info = INFO){
  mat.cs = x
  
  # older try, also works...
  #mat.Rank <- apply(mat.cs, MARGIN = 2, TransformToRank,  DECREASE = TRUE)
  # I found out later, that the rank() function exists....
  mat.rank <- apply(mat.cs, MARGIN = 2, GetRank,  DECREASE = TRUE)
  
  mat.rank.BIN1 <- mat.rank[,grep("D7",colnames(mat.rank))]
  mat.rank.BIN2 <- mat.rank[,grep("D14",colnames(mat.rank))]
  mat.rank.BIN3 <- mat.rank[,grep("D21",colnames(mat.rank))]
  mat.rank.BIN4 <- mat.rank[,grep("D27",colnames(mat.rank))]
  
  mat.RRA.des <-  apply(mat.rank, MARGIN = 1,rhoScores)
  mat.RRA.BIN1.des <-  apply(mat.rank.BIN1, MARGIN = 1,rhoScores)
  mat.RRA.BIN2.des <-  apply(mat.rank.BIN2, MARGIN = 1,rhoScores)
  mat.RRA.BIN3.des <-  apply(mat.rank.BIN3, MARGIN = 1,rhoScores)
  mat.RRA.BIN4.des <-  apply(mat.rank.BIN4, MARGIN = 1,rhoScores)
  
  
  
  mat.rank <- apply(mat.cs, MARGIN = 2, GetRank,  DECREASE = FALSE)
  
  mat.rank.BIN1 <- mat.rank[,grep("D7",colnames(mat.rank))]
  mat.rank.BIN2 <- mat.rank[,grep("D14",colnames(mat.rank))]
  mat.rank.BIN3 <- mat.rank[,grep("D21",colnames(mat.rank))]
  mat.rank.BIN4 <- mat.rank[,grep("D27",colnames(mat.rank))]
  
  mat.RRA.inc <-  apply(mat.rank, MARGIN = 1,rhoScores)
  mat.RRA.BIN1.inc <-  apply(mat.rank.BIN1, MARGIN = 1,rhoScores)
  mat.RRA.BIN2.inc <-  apply(mat.rank.BIN2, MARGIN = 1,rhoScores)
  mat.RRA.BIN3.inc <-  apply(mat.rank.BIN3, MARGIN = 1,rhoScores)
  mat.RRA.BIN4.inc <-  apply(mat.rank.BIN4, MARGIN = 1,rhoScores)
  
  if (all(names(mat.RRA.des) == names(mat.RRA.inc)) &
      all(names(mat.RRA.BIN1.des) == names(mat.RRA.BIN1.inc)) &
      all(names(mat.RRA.BIN2.des) == names(mat.RRA.BIN2.inc)) &
      all(names(mat.RRA.BIN3.des) == names(mat.RRA.BIN3.inc)) &
      all(names(mat.RRA.BIN4.des) == names(mat.RRA.BIN4.inc))){
    
    RRA.overall <- rowMin(cbind(mat.RRA.des,mat.RRA.inc))
    RRA.BIN1 <- rowMin(cbind(mat.RRA.BIN1.des,mat.RRA.BIN1.inc))
    RRA.BIN2 <- rowMin(cbind(mat.RRA.BIN2.des,mat.RRA.BIN2.inc))
    RRA.BIN3 <- rowMin(cbind(mat.RRA.BIN3.des,mat.RRA.BIN3.inc))
    RRA.BIN4 <- rowMin(cbind(mat.RRA.BIN4.des,mat.RRA.BIN4.inc))
    
  }
  else{
    stop("guides are not in the correct order")
  }
  
  
  names(RRA.overall) <- names(mat.RRA.des)
  names(RRA.BIN1) <- names(mat.RRA.BIN1.des)
  names(RRA.BIN2) <- names(mat.RRA.BIN2.des)
  names(RRA.BIN3) <- names(mat.RRA.BIN3.des)
  names(RRA.BIN4) <- names(mat.RRA.BIN4.des)
  
  
  
  RRA <- cbind(RRA.overall,RRA.BIN1,RRA.BIN2,RRA.BIN3,RRA.BIN4)
  colnames(RRA) <- c("p.all","p.D7","p.D14","p.D21","p.D27")
  RRA <- as.data.frame(RRA)
  RRA$logAll <- -log10(RRA$p.all)
  RRA$logD7 <- -log10(RRA$p.D7)
  RRA$logD14 <- -log10(RRA$p.D14)
  RRA$logD21 <- -log10(RRA$p.D21)
  RRA$logD27 <- -log10(RRA$p.D27)
  
  RRA$meanCS.D7 <- rowMeans(as.matrix(mat.cs[,grep("D7",colnames(mat.cs))]), na.rm = T)
  RRA$meanCS.D14 <- rowMeans(as.matrix(mat.cs[,grep("D14",colnames(mat.cs))]), na.rm = T)
  RRA$meanCS.D21 <- rowMeans(as.matrix(mat.cs[,grep("D21",colnames(mat.cs))]), na.rm = T)
  RRA$meanCS.D27 <- rowMeans(as.matrix(mat.cs[,grep("D27",colnames(mat.cs))]), na.rm = T)
  
  RRA$medianCS.D7 <- rowMedians(as.matrix(mat.cs[,grep("D7",colnames(mat.cs))]), na.rm = T)
  RRA$medianCS.D14 <- rowMedians(as.matrix(mat.cs[,grep("D14",colnames(mat.cs))]), na.rm = T)
  RRA$medianCS.D21 <- rowMedians(as.matrix(mat.cs[,grep("D21",colnames(mat.cs))]), na.rm = T)
  RRA$medianCS.D27 <- rowMedians(as.matrix(mat.cs[,grep("D27",colnames(mat.cs))]), na.rm = T)
  
  
  
  RRA$Guide <- sapply(rownames(RRA),GetType)
  RRA$Guide <- factor(RRA$Guide, levels =   c("TOP","BOTTOM","Non-Targeting"))
  RRA$Class <- AssignINFO(rownames(RRA) , info = INFO)
  RRA$Class = gsub("PositiveRegulator","NG",RRA$Class)
  RRA$Class = gsub("NegativeRegulator","EG",RRA$Class)
  RRA$Class = factor( RRA$Clas, levels = c("NG","EG","nonTargeting"))
  RRA$Gene = sapply(rownames(RRA),FUN = function(y){strsplit(y , "_")[[1]][1]})
  m = match(rownames(RRA) , info$GuideName)
  RRA$TranscriptID = info$TranscriptID[m]
  RRA$GuideSeq = info$GuideSeq[m]
  RRA$GuideRank = info$Rank[m]
  RRA$standardizedGuideScores = info$standardizedGuideScores[m]
  RRA$quartiles = info$quartiles[m]
  RRA$ExonJunction = info$ExonJunction[m]
  

  OUT = RRA
  
  RRA = RRA[grep("nonTargeting",RRA$Class, invert = T),]
  
  cbbPalette <- c( "#3182bd","#de2d26",  "#999999")
  
  g1 <- ggplot(aes(y=RRA$logD7, x=RRA$meanCS.D7), data = RRA) + geom_point(aes(color = Guide), size = 1, alpha = 1) + 
    xlab("log2(D7/D0)") + ylab("-log10(RRA)") +
    facet_wrap(Class ~ .) +
    theme_classic() + ylim(c(0,22.5)) + xlim(c(-5,1))  + ggtitle(NAME) + coord_fixed(ratio=0.26) +
    scale_color_manual(values=cbbPalette)
  
  g2 <-  ggplot(aes(y=RRA$logD14, x=RRA$meanCS.D14), data = RRA) + geom_point(aes(color = Guide), size = 1, alpha = 1) + 
    xlab("log2(D14/D0)") + ylab("-log10(RRA)") +
    facet_wrap(Class ~ .) +
    theme_classic() + ylim(c(0,22.5)) + xlim(c(-5,1))  + ggtitle(NAME) + coord_fixed(ratio=0.26) +
    scale_color_manual(values=cbbPalette)
  
  g3 <-  ggplot(aes(y=RRA$logD21, x=RRA$meanCS.D21), data = RRA) + geom_point(aes(color = Guide), size = 1, alpha = 1) + 
    xlab("log2(D21/D0)") + ylab("-log10(RRA)") +
    facet_wrap(Class ~ .) +
    theme_classic() + ylim(c(0,22.5)) + xlim(c(-5,1))  + ggtitle(NAME) + coord_fixed(ratio=0.26) +
    scale_color_manual(values=cbbPalette)
  
  g4 <-  ggplot(aes(y=RRA$logD27, x=RRA$meanCS.D27), data = RRA) + geom_point(aes(color = Guide), size = 1, alpha = 1) +  
    xlab("log2(D27/D0)") + ylab("-log10(RRA)") +
    facet_wrap(Class ~ .) +
    theme_classic() + ylim(c(0,22.5)) + xlim(c(-5,1))  + ggtitle(NAME) + coord_fixed(ratio=0.26) +
    scale_color_manual(values=cbbPalette)
  
  g5 <-  ggplot(aes(y=RRA$logAll, x=RRA$meanCS.D27), data = RRA) + geom_point(aes(color = Guide), size = 1, alpha = 1) +  
    xlab("log2(D27/D0)") + ylab("-log10(RRA-all)") +
    facet_wrap(Class ~ .) +
    theme_classic() + ylim(c(0,22.5)) + xlim(c(-5,1))  + ggtitle(NAME) + coord_fixed(ratio=0.26) +
    scale_color_manual(values=cbbPalette)
  
 
  
  l <- list()
  l[[1]] <- OUT
  l[[2]] <- g1
  l[[3]] <- g2
  l[[4]] <- g3
  l[[5]] <- g4
  l[[6]] <- g5

  names(l) <- c("RRA_results", "Volcano_plot_mean_D7","Volcano_plot_mean_D14","Volcano_plot_mean_D21","Volcano_plot_mean_D27", "Volcano_plot_mean_D27all")
  return(l)
}

GetRank <- function(y, DECREASE = TRUE){
  if(DECREASE == T){
    n <- rank(-y , na.last = T, ties.method = "last") / length(y)
    
  }
  else{
    n <- rank(y , na.last = T, ties.method = "last") / length(y)
  }
  return(n)
}


PlotTimecourseReplicate = function(x, NAME = ""){
  tmp <- as.data.frame(x)
  tmp$Guide <- sapply(rownames(tmp),GetType)
  tmp$class <- AssignINFO(rownames(tmp) , info = INFO)
  tmp$class = gsub("PositiveRegulator","Non-essential Gene (NG)",tmp$class)
  tmp$class = gsub("NegativeRegulator","Essential Gene (EG)",tmp$class)
  tmp$class = gsub("nonTargeting","Non-Targeting (NT)",tmp$class)
  df <- melt(tmp, id.vars = c("Guide","class"))
  df$Guide <- factor(df$Guide, levels =   c("TOP","BOTTOM","Non-Targeting"))
  df$variable <- factor(df$variable, levels =   order[grep("D",order)])
  df$class <- factor(df$class, levels =   c("Non-essential Gene (NG)","Essential Gene (EG)","Non-Targeting (NT)"))
  
  cbbPalette <- c( "#3182bd","#de2d26",  "#999999")
  p = ggplot(df, aes(fill = Guide ,x=variable, y=value )) + 
    facet_wrap( ~ class) +
    geom_boxplot( aes(color = Guide), fill = "#ffffff",  outlier.size = -1 , position = position_dodge2(preserve = "single")) + 
    geom_point(pch = 21, size = 0.75,  position = position_jitterdodge(seed = 1234), stroke = 0.2) +
    theme_classic() + ylab("guide enrichment log2(Dxx/D0)") + xlab("") + ggtitle(NAME) +
    scale_fill_manual(values=cbbPalette) +
    scale_color_manual(values=cbbPalette) +
    theme(axis.text.x = element_text(angle = 90, hjust = 0.5, vjust=0.5))
  
  return(p)
}


CompareHighLow = function(dat){
  high = dat[grep("T",dat$Guide),]
  low = dat[grep("T",dat$Guide, invert = TRUE),]
  p = signif( t.test(high$value , low$value , alternative = 'less')$p.value , 3)
  return(p)
}
TranslatePval <- function(x){
  if( x > 0.05){
    return("")
  } else if (x >= 0.01 & x < 0.05 ){
    return("*")
  } else if (x >= 0.001 & x < 0.01 ){
    return("**")
  } else if ( x < 0.001 ){
    return("***")
  }
}

PlotByGeneByGuide = function(x, NAME = ""){
  
  tmp = as.data.frame(x)
  tmp$Gene = sapply(rownames(tmp) , FUN = function(z){strsplit(z, "_")[[1]][1]})
  tmp$type <- sapply(rownames(tmp),GetType)
  tmp$class <- AssignINFO(rownames(tmp) , info = INFO)
  tmp$Guide = sapply(rownames(tmp) , FUN = function(z){strsplit(z, "_")[[1]][2]})
  df <- melt(tmp, id.vars = c("type","class","Gene","Guide"))
  df$Replicate = sapply(as.character(df$variable) , FUN = function(z){strsplit(z, "_")[[1]][1]})
  df$Day = sapply(as.character(df$variable) , FUN = function(z){strsplit(z, "_")[[1]][2]})
  df = df[grep("Non-Targeting",df$type, invert = T),]
  df$type <- factor(df$type, levels =   c("TOP","BOTTOM"))
  df$variable <- factor(df$variable, levels =   order[grep("D",order)])
  df$class <- factor(df$class, levels =   c("PositiveRegulator","NegativeRegulator"))
  df$Guide <- factor(df$Guide, levels =   c("T1","T2","T3","B1","B2","B3"))
  
  D = split(df , f = df$Day)
  
  G = list()
  for ( i in 1:length(D)){
    df = D[[i]]
    Y=max( df$value)+0.35
    df.tmp = df[grep("TOP",df$type),]
    means = aggregate(value ~  Gene, df.tmp, mean)
    means = means[order(means$value,decreasing = F),]
    means$lbl = ifelse(means$Gene %in% df$Gene[which(as.character(df$class) == "NegativeRegulator")] , "EG" , "")
    means$pos = seq(1,nrow(means),1)
    df$Gene <- factor(df$Gene, levels =   means$Gene)
    
    # compare high-scoring vs low-scoring guides
    ByGene = split(df , df$Gene)
    pvalues = sapply(ByGene,CompareHighLow)
    significance = sapply(pvalues,TranslatePval)
    idx = match(means$Gene , names(significance))
    means$significance = significance[idx]
    
    

    # df.tmp = df[grep("NegativeRegulator",df$class),]
    # p = quantile(df.tmp$value , probs = 0.5)
    df$var2 = paste0(df$Gene,"_",df$Guide)
    var2.means = aggregate(value ~  var2, df, mean)
    p = sort(var2.means$value , decreasing = FALSE)[30]
    m = match(var2.means$var2 , df$var2)
    var2.means$class = df$class[m]
    var2.means$class = gsub("NegativeRegulator","EG",var2.means$class)
    var2.means$class = gsub("PositiveRegulator","NG",var2.means$class)
    var2.means$type = df$type[m]
    var2.means$type = gsub("TOP","T",var2.means$type)
    var2.means$type = gsub("BOTTOM","B",var2.means$type)
    var2.means$is.essential = ifelse(var2.means$value <= p , TRUE, FALSE )
    var2.means$cat = paste0(var2.means$class,"_",var2.means$type)
    
    
    C = split(var2.means , f = var2.means$cat)
    ROC = melt(lapply(C, function(y){table(y$is.essential)}))
    colnames(ROC) = c("is.essential", "value", "cat")
    ROC$class = sapply(ROC$cat , FUN = function(z){strsplit(z, "_")[[1]][1]})
    ROC$Guide = sapply(ROC$cat , FUN = function(z){strsplit(z, "_")[[1]][2]})
    ROC$cat = factor( ROC$cat , levels = c("EG_T", "EG_B", "NG_T", "NG_B"))
    Val = ROC$value[which(ROC$is.essential == TRUE & ROC$cat == "EG_T")]
    Percent = paste0(round(ROC$value[which(ROC$is.essential == TRUE & ROC$cat == "EG_T")]/30*100),"%") 
    g = ggplot(ROC , aes( x = cat , y = value, fill = is.essential))+
      geom_bar( stat = 'identity', color = "#636363") +
      theme_classic() +
      scale_fill_manual(values = c("#ffffff","#3182bd"), name = "") +
      ylab("#")+
      xlab("") +
      theme(legend.text=element_text(size=6))+
      theme(axis.text.x = element_text(angle = 90, hjust = 1, vjust=0.5)) +
      annotate('text', x = 1 , y = Val-1 , label = Percent , vjust=1 , size = 2 )
    
    
    
    
    G[[i]] = ggplot(df, aes(fill = Guide ,x=Gene, y=value )) +
      geom_boxplot(aes(color = Guide), fill=NA)+
      geom_point(pch = 21, position = position_jitterdodge(), stroke = 0.2)+
      theme_classic() +
      ylab(paste0("log2(",names(D)[i],"/D0)")) +
      theme(axis.text.x = element_text(angle = 90, hjust = 1, vjust=0.5)) +
      scale_color_manual(values = c(c("#6baed6", "#4292c6","#2171b5"),c("#fb6a4a","#ef3b2c","#cb181d")))+
      scale_fill_manual(values = c(c("#6baed6", "#4292c6","#2171b5"),c("#fb6a4a","#ef3b2c","#cb181d")))+
      geom_vline(xintercept=seq(2,nrow(means),1)-0.5, linetype="solid", color = "#bdbdbd", size=0.1) +
      geom_hline(yintercept=p, linetype="dashed", color = "#636363", size=0.25) +
      annotate(geom = "text",  x=means$pos, y=Y, label = means$lbl,  size=2) +
      annotate(geom = "text",  x=means$pos, y=Y-0.2, label = means$significance,  size=4) +
      ggtitle(NAME) + 
      annotation_custom(ggplotGrob(g), xmin = 12, xmax = 20, 
                        ymin = min(df$value), ymax = c(min(df$value)+(sum(abs(range(df$value)))*0.7)) )
    
  }
  names(G)=names(D)
  return(G)
  
}


PlotByGene = function(x, NAME = ""){
  
  tmp = as.data.frame(x)
  tmp$Gene = sapply(rownames(tmp) , FUN = function(z){strsplit(z, "_")[[1]][1]})
  tmp$type <- sapply(rownames(tmp),GetType)
  tmp$class <- AssignINFO(rownames(tmp) , info = INFO)
  tmp$Guide = sapply(rownames(tmp) , FUN = function(z){strsplit(z, "_")[[1]][2]})
  df <- melt(tmp, id.vars = c("type","class","Gene","Guide"))
  df$Replicate = sapply(as.character(df$variable) , FUN = function(z){strsplit(z, "_")[[1]][1]})
  df$Day = sapply(as.character(df$variable) , FUN = function(z){strsplit(z, "_")[[1]][2]})
  df = df[grep("Non-Targeting",df$type, invert = T),]
  df$type <- factor(df$type, levels =   c("TOP","BOTTOM"))
  df$variable <- factor(df$variable, levels =   order[grep("D",order)])
  df$class <- factor(df$class, levels =   c("PositiveRegulator","NegativeRegulator"))
  df$Guide <- factor(df$Guide, levels =   c("T1","T2","T3","B1","B2","B3"))
  
  D = split(df , f = df$Day)
  
  G = list()
  for ( i in 1:length(D)){
    df = D[[i]]
    Y=max( df$value)+0.35
    df.tmp = df[grep("TOP",df$type),]
    means = aggregate(value ~  Gene, df.tmp, mean)
    means = means[order(means$value,decreasing = F),]
    means$lbl = ifelse(means$Gene %in% df$Gene[which(as.character(df$class) == "NegativeRegulator")] , "EG" , "")
    means$pos = seq(1,nrow(means),1)
    df$Gene <- factor(df$Gene, levels =   means$Gene)
    
    
    
    G[[i]] = ggplot(df, aes(fill = type ,x=Gene, y=value )) +
      geom_boxplot(aes(color = type), fill=NA)+
      geom_point(pch = 21, position = position_jitterdodge(), stroke = 0.2)+
      theme_classic() +
      ylab(paste0("log2(",names(D)[i],"/D0)")) +
      theme(axis.text.x = element_text(angle = 90, hjust = 1, vjust=0.5)) +
      scale_color_manual(values = c("#3182bd","#de2d26"))+
      scale_fill_manual(values = c("#3182bd","#de2d26"))+
      geom_vline(xintercept=seq(2,nrow(means),1)-0.5, linetype="solid", color = "#bdbdbd", size=0.1) +
      annotate(geom = "text",  x=means$pos, y=Y, label = means$lbl , size=2) +
      ggtitle(NAME)
    
  }
  names(G)=names(D)
  return(G)
  
}

PlotTimecourse = function(x, NAME = ""){
  tmp <- as.data.frame(x)
  tmp$Guide <- sapply(rownames(tmp),GetType)
  tmp$class <- AssignINFO(rownames(tmp) , info = INFO)
  tmp$class = gsub("PositiveRegulator","Non-essential Gene (NG)",tmp$class)
  tmp$class = gsub("NegativeRegulator","Essential Gene (EG)",tmp$class)
  tmp$class = gsub("nonTargeting","Non-Targeting (NT)",tmp$class)
  df <- melt(tmp, id.vars = c("Guide","class"))
  df$Guide <- factor(df$Guide, levels =   c("TOP","BOTTOM","Non-Targeting"))
  df$variable <- factor(df$variable, levels =   order[grep("D",order)])
  df$class <- factor(df$class, levels =   c("Non-essential Gene (NG)","Essential Gene (EG)","Non-Targeting (NT)"))
  df$Day = sapply(as.character(df$variable) , FUN = function(y){strsplit(y,"_")[[1]][2]})
  df$Day = factor(df$Day , levels = c("D7","D14","D21","D27"))
  
  cbbPalette <- c( "#3182bd","#de2d26",  "#999999")
  p = ggplot(df, aes(fill = Guide ,x=Day, y=value )) + 
    facet_wrap( ~ class) +
    geom_boxplot( aes(color = Guide), fill = "#ffffff",  outlier.size = -1 , position = position_dodge2(preserve = "single")) + 
    geom_point(pch = 21, size = 0.75,  position = position_jitterdodge(seed = 1234), stroke = 0.2) +
    theme_classic() + ylab("guide enrichment log2(Dxx/D0)") + xlab("") + ggtitle(NAME) +
    scale_fill_manual(values=cbbPalette) +
    scale_color_manual(values=cbbPalette) +
    theme(axis.text.x = element_text(angle = 90, hjust = 0.5, vjust=0.5))
  
  return(p)
}

AssignINFO = function(x , info = INFO){
  m = match( x, info$GuideName)
  info$class[m]
}
########################## sub-routines end  ########

###### execute ######################################


#### generate raw count matrix

cat( paste0("\n Generate raw count matrix: ",date(),"\n"))

#load crRNA count results
crRNA.files <- list.files(path = "./data",  recursive = T, full.names = T,pattern = "crRNA.summary.txt$")
crRNA <- lapply(crRNA.files , FUN = function(x){as.data.frame(read.table(x, header = F, as.is = T, sep = "\t", stringsAsFactors = F))})
names(crRNA) <- sapply(crRNA.files , GetName, y=3)



# confirm all rownames are the same
rn = vector()
for ( i in 1:length(crRNA)){
  rn[i] = all(crRNA[[1]][,1] == crRNA[[i]][,1])
}

if( !all(rn) ){
  stop("Exiting. Incorrect guide order.")
}

# transform into count matrix; the order is the same in all crRNA list entries
crMat <- do.call(cbind, lapply(crRNA, function(x){x[,2]}))
# assign rownames
rownames(crMat) <- crRNA[[1]][,1]

ID_matrix = cbind(c("R1-F8", "R1-F9", "R1-F10", "R1-F11", "R1-F12", "R2-F8",  "R2-F9", "R2-F10", "R2-F11", "R2-F12", "R3-F8", "R3-F9" ,"R3-F10", "R3-F11", "R3-F12"),
                             c("R1_D0", "R1_D7", "R1_D14", "R1_D21", "R1_D27", "R2_D0", "R2_D7", "R2_D14", "R2_D21", "R2_D27", "R3_D0", "R3_D7", "R3_D14", "R3_D21", "R3_D27"))
colnames(ID_matrix) = c("Barcodes","Sample")

#rename samples
for (i in 1:length(colnames(crMat))){
  idx = which( ID_matrix[,"Barcodes"] == colnames(crMat)[i]  )
  colnames(crMat)[i] = ID_matrix[,"Sample"][idx]
}

order <- c("R1_D0", "R2_D0", "R3_D0", 
           "R1_D7", "R2_D7", "R3_D7",   
           "R1_D14", "R2_D14", "R3_D14",
           "R1_D21", "R2_D21","R3_D21", 
           "R1_D27","R2_D27","R3_D27")

crMat = crMat[,order]


# remove undetected guides
del = which(rowSums(crMat) == 0)
if (length(del) > 0){
  crMat = crMat[-del,]
}
print(paste0( length(del) ," guide RNAs have not been detected"))


# remove guides if barely detected in input samples
del = which(rowMins(crMat[,grep("nput", colnames(crMat))]) < 50)
if (length(del) > 0){
  crMat = crMat[-del,]
}
print(paste0( length(del) ," guide RNAs have been removed entirely due to low detection in input samples using a 50 read cutoff"))

# remove guides if not detected in any other sample
del = which(rowMins(crMat) == 0)
if (length(del) > 0){
  crMat = crMat[-del,]
}
print(paste0( length(del) ," guide RNAs have been removed entirely due to low detection in any samples using a 0 read cutoff"))




crMat.raw <- crMat

write.table(crMat.raw , file = "./data/HEK_count_matrix_raw.csv", sep=",", col.names = T, row.names = T, quote = F)






#### normalize counts

cat( paste0("\n Normalize counts: ",date(),"\n"))

# see https://hbctraining.github.io/DGE_workshop/lessons/02_DGE_count_normalization.html

mat=crMat.raw

# STEP 1 - build pseudo reference
PseudoRef <- apply(mat, MARGIN = 1, gm_mean)

# STEP 2 - normalize w/ median of ratios
Norm.mat.list <- NormalizeLikeDEseq( x= mat, ref = PseudoRef)

crMat.norm <- Norm.mat.list$normalized_counts

write.table(crMat.norm , file = "./data/HEK_count_matrix_normalized.csv", sep=",", col.names = T, row.names = T, quote = F)





#### Batch correction

cat( paste0("\n Batch correction: ",date(),"\n"))

# normalized count matrix
mat=crMat.norm

# get batch info
# batchMat <- cbind(colnames(mat), sapply(colnames(mat),function(x){strsplit(x, split="_")[[1]][1]}),sapply(colnames(mat),function(x){strsplit(x, split="_")[[1]][2]}))
# colnames(batchMat) <- c("sample","batch","bin")
batchMat <- cbind(colnames(mat), sapply(colnames(mat),function(x){strsplit(x, split="_")[[1]][1]}))
colnames(batchMat) <- c("sample","batch")


# Run sva embedded in BatchRemove from Mageckflute
RemovedBatch <- BatchRemove(mat = mat, batchMat = batchMat  , log2trans = T)

crMat.BatchCorrected.log <- RemovedBatch[[1]] 

crMat.BatchCorrected <- apply(crMat.BatchCorrected.log , MARGIN = 2, exp)

write.table(crMat.BatchCorrected , file = "./data/HEK_count_matrix_normalized_batchcorrected.csv", sep=",", col.names = T, row.names = T, quote = F)



### Outlier Masking has not been performed, as no noticible outliers have been found



####### Visualize data structure improvement due to processing

cat( paste0("\n Plot data structure improvement due to processing: ",date(),"\n"))

# define symmetric breaks and generalizing color scheme
co = c(cor(crMat.raw, method = "spearman"), cor(crMat.norm, method = "spearman"),  cor(crMat.BatchCorrected, method = "spearman"))
mn = co[which(co == min(co, na.rm = T))[1]] 
mx = co[which(co == max(co, na.rm = T))[1]] 
s <- mx - mn
breaksList.sp = seq(mn,mx, by = s/100)

co = c(cor(log2(crMat.raw), method = "pearson"), cor(log2(crMat.norm), method = "pearson"),  cor(log2(crMat.BatchCorrected), method = "pearson"))
mn = co[which(co == min(co, na.rm = T))[1]] 
mx = co[which(co == max(co, na.rm = T))[1]] 
s <- mx - mn
breaksList.pe = seq(mn,mx, by = s/100)

annotation = data.frame(D = factor(rep(c(1:5),each = 3), labels = c("D0", "D7", "D14", "D21", "D27")),
                        Replicate = factor(rep(c(1:3),times = 5), labels = c("1", "2", "3")))
D = (c("#edf8e9", "#a1d99b", "#41ab5d", "#005a32", "#525252"))
names(D) = c("D0", "D7", "D14", "D21", "D27")
Replicate = c("#7a0177", "#dd3497","#fa9fb5")
names(Replicate) = c("1", "2", "3")
ann_colors = list(D = D, Replicate = Replicate)



pdf("./figures/QC_HEK_processing.pdf", height = 15, width = 12, useDingbats = F, onefile = F)
par(mfcol=c(3,2))
aheatmap( cor(crMat.raw, method = "spearman") , distfun = "euclidean", hclustfun = "ward", cellwidth = 10, cellheight = 10,  breaks = breaksList.sp, annCol = annotation, annRow = annotation,  annColors = ann_colors, labCol = NA, sub = "raw counts")
text(x = -37 , y = 8 , "spearman coef.", srt = 90 )
aheatmap(cor(crMat.norm, method = "spearman"), distfun = "euclidean", hclustfun = "ward", cellwidth = 10, cellheight = 10,  breaks = breaksList.sp, annCol = annotation, annRow = annotation,  annColors = ann_colors, labCol = NA, sub = "normalized counts")
text(x = -37 , y = 8 , "spearman coef.", srt = 90)
aheatmap(cor(crMat.BatchCorrected, method = "spearman"), distfun = "euclidean", hclustfun = "ward", cellwidth = 10, cellheight = 10,  breaks = breaksList.sp, annCol = annotation, annRow = annotation,  annColors = ann_colors, labCol = NA, sub = "batch-corrected normalized counts")
text(x = -26 , y = 8 , "spearman coef.", srt = 90)
# aheatmap(cor(crMat.processedCounts, method = "spearman", use="complete.obs"), distfun = "euclidean", hclustfun = "ward", cellwidth = 10, cellheight = 10,  breaks = breaksList.sp, annCol = annotation, annRow = annotation,  annColors = ann_colors, labCol = NA,  sub = "batch-corrected normalized outlier-removed counts")
# text(x = -37 , y = 8 , "spearman coef.", srt = 90)

aheatmap(cor(log2(crMat.raw), method = "pearson"), distfun = "euclidean", hclustfun = "ward",cellwidth = 10, cellheight = 10,  breaks = breaksList.pe, annCol = annotation, annRow = annotation,  annColors = ann_colors, labCol = NA, sub = "raw counts")
text(x = -64 , y = 8 , "pearson coef.", srt = 90)
aheatmap(cor(log2(crMat.norm), method = "pearson"), distfun = "euclidean", hclustfun = "ward", cellwidth = 10, cellheight = 10,  breaks = breaksList.pe, annCol = annotation, annRow = annotation,  annColors = ann_colors, labCol = NA, sub = "normalized counts")
text(x = -64  , y = 8 , "pearson coef.", srt = 90)
aheatmap(cor(log2(crMat.BatchCorrected), method = "pearson"), distfun = "euclidean", hclustfun = "ward", cellwidth = 10, cellheight = 10,  breaks = breaksList.pe, annCol = annotation, annRow = annotation,  annColors = ann_colors, labCol = NA, sub = "batch-corrected normalized counts")
text(x = -50  , y = 8 , "pearson coef.", srt = 90)
# aheatmap(cor(log2(crMat.processedCounts), method = "pearson", use = "complete.obs"), distfun = "euclidean", hclustfun = "ward", cellwidth = 10, cellheight = 10,  breaks = breaksList.pe, annCol = annotation, annRow = annotation,  annColors = ann_colors, labCol = NA, sub = "batch-corrected normalized outlier-removed counts",)
# text(x = -45  , y = 8 , "pearson coef.", srt = 90)
dev.off()




# PCA
Transformations <- list(crMat.raw, crMat.norm, crMat.BatchCorrected)
names(Transformations) <- c("raw","norm","batch-corrected")
P = list()

for ( i in 1:length(Transformations)){
  P[[i]] = Plot.pca(Transformations[[i]], NAME = names(Transformations)[i])
}

pdf("./figures/QC_HEK_PCA.pdf", width = 8, height = 12, useDingbats = F)
grid.arrange(P[[1]][[1]],P[[1]][[2]],P[[2]][[1]],P[[2]][[2]],P[[3]][[1]],P[[3]][[2]], ncol=2)
dev.off()











####### Assign CRISPR SCORE (= log2(Dxx read count / D0 read count))

cat( paste0("\nCalculate CRISPR Scores: ",date(),"\n"))

INFO = read.delim("./data/HEKessentialiltScreen_Guides.tsv" , header = T, sep = '\t', stringsAsFactors = F)

#calculate CRISPR SCORE (CS) == log2(Dxx/D0)
Masked.list = list((crMat.raw),(crMat.norm),(crMat.BatchCorrected))
names(Masked.list) = c("raw","norm","batch_corrected")
CS.list <- lapply( Masked.list , AssignCScore )





# plot results
# Timecourse distribution of CS
g=list()
G=list()
for(i in 1:length(CS.list)){
  g[[i]] = PlotTimecourseReplicate(x = CS.list[[i]], NAME = names(CS.list)[i])
  G[[i]] = PlotTimecourse(x = CS.list[[i]], NAME = names(CS.list)[i])
}
pdf("./figures/CRISPRscores_vs_D0_Replicates.pdf", width = 7, height = 12, useDingbats = F)
grid.arrange(g[[1]]+ylim(c(-5,2.2)) ,g[[2]]+ylim(c(-5,2.2)) ,g[[3]]+ylim(c(-5,2.2)) ,ncol=1, nrow = 3)
dev.off()
pdf("./figures/CRISPRscores_vs_D0.pdf", width = 6, height = 12, useDingbats = F)
grid.arrange(G[[1]]+ylim(c(-5,2.2)) ,G[[2]]+ylim(c(-5,2.2)) ,G[[3]]+ylim(c(-5,2.2)) ,ncol=1, nrow = 3)
dev.off()




# Distribution of CS separated by gene



i = grep("batch_corrected" ,names(CS.list))
g = PlotByGene(CS.list[[i]], names(CS.list)[i])
pdf("./figures/CRISPRscores_ByGene.pdf", width = 7, height = 15, useDingbats = F)
grid.arrange(arrangeGrob(grobs= list(g[[4]] ,g[[1]] ,g[[2]], g[[3]]) ,nrow=4, ncol = 1))
dev.off()

i = grep("batch_corrected" ,names(CS.list))
g = PlotByGeneByGuide(CS.list[[i]], names(CS.list)[i])
pdf("./figures/FigS8b_CRISPRscores_ByGeneByGuide.pdf",  width = 7, height = 15, useDingbats = F)
grid.arrange(arrangeGrob(grobs= list(g[[4]] ,g[[1]] ,g[[2]], g[[3]]) ,nrow=4, ncol = 1))
dev.off()



############################################

# Correlate CS
i = grep("batch_corrected" ,names(CS.list))
CS = CS.list[[i]]

annotation = data.frame(D = factor(rep(c(1:4),each = 3), labels = c("D7", "D14", "D21", "D27")),
                        Replicate = factor(rep(c(1:3),times = 4), labels = c("1", "2", "3")))
D = (c("#edf8e9", "#a1d99b", "#41ab5d", "#005a32"))
names(D) = c("D7", "D14", "D21", "D27")
Replicate = c("#7a0177", "#dd3497","#fa9fb5")
names(Replicate) = c("1", "2", "3")
ann_colors = list(D = D, Replicate = Replicate)


ma = cor(CS, method = "pearson", use = "complete.obs")
aheatmap(ma, distfun = "euclidean", hclustfun = "ward", cellwidth = 10, cellheight = 10,  annCol = annotation, annRow = annotation,  annColors = ann_colors, labCol = NA, main = "guide enrichment correlation", sub = "norm. counts - pearson coef.",
         filename = "./figures/QC_CRISPRscores_Pearson_Correlation.pdf")







###### Run Robust Rank Aggregation (RRA)

cat( paste0("\nRun Robust Rank Aggregation (RRA): ",date(),"\n"))

g <- list()
for (i in 1:length(CS.list)){
  g[[i]] <- RunRRA(CS.list[[i]], NAME = names(CS.list)[i])
}
names(g) = names(CS.list)


###### Plot RRA results
i = grep("batch_corrected" ,names(CS.list))

pdf("./figures/QC_HEK_CRISPRscore_vs_RRA.pdf", width = 8, height = 14, useDingbats = F)
grid.arrange(g[[i]][[2]],g[[i]][[2]],
                   g[[i]][[3]],g[[i]][[3]],
                   g[[i]][[4]],g[[i]][[4]],
                   g[[i]][[5]],g[[i]][[5]],
                   g[[i]][[6]],g[[i]][[6]],ncol=2, nrow = 5)
dev.off()


HEK_Results = g[["batch_corrected"]][[1]]

write.table( HEK_Results , file = "./data/HEK_screen_crRNA_enrichments.csv", col.names = T, row.names = T,quote = F, sep = ",")

#breaksList = seq(-1,1, by = 0.02)
ma = cor(HEK_Results[,grep("meanCS",colnames(HEK_Results))], method = "pearson", use = "complete.obs")
aheatmap(ma, distfun = "euclidean", hclustfun = "ward", cellwidth = 25, cellheight = 25, 
         labRow = gsub("meanCS.","",rownames(ma)), labCol = gsub("meanCS.","",colnames(ma)), fontsize = 5, main = "guide RNA enrichment", sub = "norm. counts - pearson coef.",
         txt = round(ma,2), filename = "./figures/QC_HEK_screen_crRNA_enrichments_PearsonCorrelation.pdf")


RRA.HEK.result.list <- g
save(RRA.HEK.result.list, file = './data/RRA.HEK.result.list.RData')



################

PlotTimecoursefinal = function(x, NAME = ""){
  tmp <- as.data.frame(x)
  tmp$Class = gsub("nonTargeting","NT",tmp$Class)
  keep = c("meanCS.D7",  "meanCS.D14",  "meanCS.D21", "meanCS.D27",
           "Guide", "Class", "Gene")
  tmp = tmp[,keep]
  df <- melt(tmp, id.vars = c("Guide","Class","Gene"))
  colnames(df)[grep("variable", colnames(df))] = 'Day'
  df$Day = gsub("meanCS.","",df$Day)
  df$Guide <- factor(df$Guide, levels =   c("TOP","BOTTOM","Non-Targeting"))
  df$Day <- factor(df$Day, levels = c("D7","D14","D21","D27"))
  df$Class <- factor(df$Class, levels =   c("NG","EG","NT"))
  
  # compare high-scoring vs low-scoring guides
  ByDay = split(df , df$Day)
  dat=ByDay[[4]]
  significance = sapply(ByDay , FUN = function(dat){
    dat = dat[grep('EG',dat$Class),]
    ByGuideClass = split(dat , as.character(dat$Guide))
    # p = signif( t.test(  ByGuideClass$TOP$value , ByGuideClass$BOTTOM$value , alternative = 'less')$p.value, 3 )
    p = signif( ks.test(    ByGuideClass$BOTTOM$value , ByGuideClass$TOP$value , alternative = 'less')$p.value, 3 )
    return(p)
  })
  

  
  cbbPalette <- c( "#3182bd","#de2d26",  "#999999")
  p = ggplot(df, aes(fill = Guide ,x=Day, y=value )) + 
    facet_wrap( ~ Class) +
    geom_boxplot( aes(color = Guide), fill = "#ffffff",  outlier.size = -1 , position = position_dodge2(preserve = "single")) + 
    geom_point(pch = 21, size = 0.75,  position = position_jitterdodge(seed = 1234), stroke = 0.2) +
    theme_classic() + ylab("guide enrichment log2(Dxx/D0)") + xlab("") + ggtitle(NAME) +
    scale_fill_manual(values=cbbPalette) +
    scale_color_manual(values=cbbPalette) +
    theme(axis.text.x = element_text(angle = 90, hjust = 1, vjust=0.5)) +
    geom_hline( yintercept = 0 )
  
  return(list(p,significance))
}

g = PlotTimecoursefinal(HEK_Results)
pdf("./figures/Fig2c_CRISPRscores_vs_D0_Summary.pdf", width = 6, height = 3, useDingbats = F)
grid.arrange(g[[1]],ncol=1, nrow = 1)
dev.off()

# Significance
cat('ks.test comparison of guide classes (high vs low) at day7, 14, 21 and day27, respectively')
print(g[[2]]) #batch-corrected
